diff --git a/src/backend/statistics/extended_stats_funcs.c b/src/backend/statistics/extended_stats_funcs.c
index a3e56933b91..d4e24c3af42 100644
--- a/src/backend/statistics/extended_stats_funcs.c
+++ b/src/backend/statistics/extended_stats_funcs.c
@@ -17,6 +17,7 @@
 #include "postgres.h"
 
 #include "access/heapam.h"
+#include "access/table.h"
 #include "catalog/indexing.h"
 #include "catalog/namespace.h"
 #include "catalog/pg_collation_d.h"
@@ -146,10 +147,8 @@ static void upsert_pg_statistic_ext_data(const Datum *values,
 
 static bool check_mcvlist_array(const ArrayType *arr, int argindex,
 								int required_ndims, int mcv_length);
-static Datum import_expressions(Relation pgsd, int numexprs,
-								Oid *atttypids, int32 *atttypmods,
-								Oid *atttypcolls, Jsonb *exprs_jsonb,
-								bool *exprs_is_perfect);
+static Datum import_expressions(Relation pgsd, List *exprnodes,
+								Jsonb *exprs_jsonb, bool *exprs_is_perfect);
 static Datum import_mcv(const ArrayType *mcv_arr,
 						const ArrayType *freqs_arr,
 						const ArrayType *base_freqs_arr,
@@ -331,10 +330,10 @@ extended_statistics_update(FunctionCallInfo fcinfo)
 	bool		nulls[Natts_pg_statistic_ext_data] = {0};
 	bool		replaces[Natts_pg_statistic_ext_data] = {0};
 	bool		success = true;
-	Datum		exprdatum;
-	bool		isnull;
+	Relation	rel;
 	List	   *exprs = NIL;
-	int			numattnums = 0;
+	Bitmapset  *keys = NULL;
+	ListCell   *lc;
 	int			numexprs = 0;
 	int			numattrs = 0;
 
@@ -342,6 +341,9 @@ extended_statistics_update(FunctionCallInfo fcinfo)
 	Oid		   *atttypids = NULL;
 	int32	   *atttypmods = NULL;
 	Oid		   *atttypcolls = NULL;
+
+	/* the expressions (declared order), for import_expressions */
+	List	   *exprnodes = NIL;
 	Oid			relid;
 	Oid			locked_table = InvalidOid;
 
@@ -439,40 +441,25 @@ extended_statistics_update(FunctionCallInfo fcinfo)
 
 	/* Find out what extended statistics kinds we should expect. */
 	expand_stxkind(tup, &enabled);
-	numattnums = stxform->stxkeys.dim1;
-
-	/* decode expression (if any) */
-	exprdatum = SysCacheGetAttr(STATEXTOID,
-								tup,
-								Anum_pg_statistic_ext_stxexprs,
-								&isnull);
-	if (!isnull)
-	{
-		char	   *s;
 
-		s = TextDatumGetCString(exprdatum);
-		exprs = (List *) stringToNode(s);
-		pfree(s);
-
-		/*
-		 * Run the expressions through eval_const_expressions().  This is not
-		 * just an optimization, but is necessary, because the planner will be
-		 * comparing them to similarly-processed qual clauses, and may fail to
-		 * detect valid matches without this.
-		 *
-		 * We must not use canonicalize_qual(), however, since these are not
-		 * qual expressions.
-		 */
-		exprs = (List *) eval_const_expressions(NULL, (Node *) exprs);
+	/*
+	 * Decode stxexprs, and collect the column attnums and expression count
+	 * needed to validate the ndistinct and dependencies inputs.
+	 */
+	rel = table_open(relid, NoLock);
+	exprs = statext_get_stxexprs(tup, rel);
+	table_close(rel, NoLock);
 
-		/* May as well fix opfuncids too */
-		fix_opfuncids((Node *) exprs);
+	foreach(lc, exprs)
+	{
+		Node	   *node = (Node *) lfirst(lc);
 
-		/* Compute the number of expression, for input validation. */
-		numexprs = list_length(exprs);
+		if (statext_is_column(node))
+			keys = bms_add_member(keys, ((Var *) node)->varattno);
+		else
+			numexprs++;
 	}
-
-	numattrs = numattnums + numexprs;
+	numattrs = list_length(exprs);
 
 	/*
 	 * If the object cannot support ndistinct, we should not have data for it.
@@ -580,54 +567,53 @@ extended_statistics_update(FunctionCallInfo fcinfo)
 	 */
 	if (has.mcv || has.expressions)
 	{
+		int			idx;
+
 		atttypids = palloc0_array(Oid, numattrs);
 		atttypmods = palloc0_array(int32, numattrs);
 		atttypcolls = palloc0_array(Oid, numattrs);
 
 		/*
-		 * The leading stxkeys are attribute numbers up through numattnums.
-		 * These keys must be in ascending AttrNumber order, but we do not
-		 * rely on that.
+		 * Get the type info for each dimension, in the same declared order as
+		 * the stored MCV values.  import_expressions() needs only the
+		 * expressions, so collect those nodes as we go.
 		 */
-		for (int i = 0; i < numattnums; i++)
+		idx = 0;
+		foreach(lc, exprs)
 		{
-			AttrNumber	attnum = stxform->stxkeys.values[i];
-			HeapTuple	atup = SearchSysCache2(ATTNUM,
-											   ObjectIdGetDatum(relid),
-											   Int16GetDatum(attnum));
-
-			Form_pg_attribute attr;
+			Node	   *node = (Node *) lfirst(lc);
 
-			/* Attribute not found */
-			if (!HeapTupleIsValid(atup))
-				elog(ERROR, "stxkeys references nonexistent attnum %d", attnum);
+			if (statext_is_column(node))
+			{
+				AttrNumber	attnum = ((Var *) node)->varattno;
+				HeapTuple	atup = SearchSysCache2(ATTNUM,
+												   ObjectIdGetDatum(relid),
+												   Int16GetDatum(attnum));
+				Form_pg_attribute attr;
 
-			attr = (Form_pg_attribute) GETSTRUCT(atup);
+				/* Attribute not found */
+				if (!HeapTupleIsValid(atup))
+					elog(ERROR, "stxexprs references nonexistent attnum %d", attnum);
 
-			if (attr->attisdropped)
-				elog(ERROR, "stxkeys references dropped attnum %d", attnum);
+				attr = (Form_pg_attribute) GETSTRUCT(atup);
 
-			atttypids[i] = attr->atttypid;
-			atttypmods[i] = attr->atttypmod;
-			atttypcolls[i] = attr->attcollation;
-			ReleaseSysCache(atup);
-		}
+				if (attr->attisdropped)
+					elog(ERROR, "stxexprs references dropped attnum %d", attnum);
 
-		/*
-		 * After all the positive number attnums in stxkeys come the negative
-		 * numbers (if any) which represent expressions in the order that they
-		 * appear in stxdexpr.  Because the expressions are always
-		 * monotonically decreasing from -1, there is no point in looking at
-		 * the values in stxkeys, it's enough to know how many of them there
-		 * are.
-		 */
-		for (int i = numattnums; i < numattrs; i++)
-		{
-			Node	   *expr = list_nth(exprs, i - numattnums);
+				atttypids[idx] = attr->atttypid;
+				atttypmods[idx] = attr->atttypmod;
+				atttypcolls[idx] = attr->attcollation;
+				ReleaseSysCache(atup);
+			}
+			else
+			{
+				atttypids[idx] = exprType(node);
+				atttypmods[idx] = exprTypmod(node);
+				atttypcolls[idx] = exprCollation(node);
 
-			atttypids[i] = exprType(expr);
-			atttypmods[i] = exprTypmod(expr);
-			atttypcolls[i] = exprCollation(expr);
+				exprnodes = lappend(exprnodes, node);
+			}
+			idx++;
 		}
 	}
 
@@ -659,7 +645,7 @@ extended_statistics_update(FunctionCallInfo fcinfo)
 		bytea	   *data = DatumGetByteaPP(ndistinct_datum);
 		MVNDistinct *ndistinct = statext_ndistinct_deserialize(data);
 
-		if (statext_ndistinct_validate(ndistinct, &stxform->stxkeys,
+		if (statext_ndistinct_validate(ndistinct, keys,
 									   numexprs, WARNING))
 		{
 			values[Anum_pg_statistic_ext_data_stxdndistinct - 1] = ndistinct_datum;
@@ -678,7 +664,7 @@ extended_statistics_update(FunctionCallInfo fcinfo)
 		bytea	   *data = DatumGetByteaPP(dependencies_datum);
 		MVDependencies *dependencies = statext_dependencies_deserialize(data);
 
-		if (statext_dependencies_validate(dependencies, &stxform->stxkeys,
+		if (statext_dependencies_validate(dependencies, keys,
 										  numexprs, WARNING))
 		{
 			values[Anum_pg_statistic_ext_data_stxddependencies - 1] = dependencies_datum;
@@ -721,18 +707,7 @@ extended_statistics_update(FunctionCallInfo fcinfo)
 
 		pgsd = table_open(StatisticRelationId, RowExclusiveLock);
 
-		/*
-		 * Generate the expressions array.
-		 *
-		 * The atttypids, atttypmods, and atttypcolls arrays have all the
-		 * regular attributes listed first, so we can pass those arrays with a
-		 * start point after the last regular attribute.  There are numexprs
-		 * elements remaining.
-		 */
-		datum = import_expressions(pgsd, numexprs,
-								   &atttypids[numattnums],
-								   &atttypmods[numattnums],
-								   &atttypcolls[numattnums],
+		datum = import_expressions(pgsd, exprnodes,
 								   PG_GETARG_JSONB_P(EXPRESSIONS_ARG),
 								   &ok);
 
@@ -1559,11 +1534,10 @@ pg_statistic_error:
  * This datum is needed to fill out a complete pg_statistic_ext_data tuple.
  */
 static Datum
-import_expressions(Relation pgsd, int numexprs,
-				   Oid *atttypids, int32 *atttypmods,
-				   Oid *atttypcolls, Jsonb *exprs_jsonb,
-				   bool *exprs_is_perfect)
+import_expressions(Relation pgsd, List *exprnodes,
+				   Jsonb *exprs_jsonb, bool *exprs_is_perfect)
 {
+	int			numexprs = list_length(exprnodes);
 	const char *argname = extarginfo[EXPRESSIONS_ARG].argname;
 	Oid			pgstypoid = get_rel_type_id(StatisticRelationId);
 	ArrayBuildState *astate = NULL;
@@ -1625,12 +1599,13 @@ import_expressions(Relation pgsd, int numexprs,
 			case jbvBinary:
 				{
 					bool		sta_ok = false;
+					Node	   *node = (Node *) list_nth(exprnodes, i);
 
 					/* a real stats object */
 					pgstdat = import_pg_statistic(pgsd, elem->val.binary.data,
 												  exprattnum, &array_in_fn,
-												  atttypids[i], atttypmods[i],
-												  atttypcolls[i], &sta_ok);
+												  exprType(node), exprTypmod(node),
+												  exprCollation(node), &sta_ok);
 
 					/*
 					 * If some incorrect data has been found, assign NULL for
diff --git a/src/backend/statistics/mcv.c b/src/backend/statistics/mcv.c
index 3e90f600ebe..9a19ec02938 100644
--- a/src/backend/statistics/mcv.c
+++ b/src/backend/statistics/mcv.c
@@ -1529,48 +1529,37 @@ pg_mcv_list_send(PG_FUNCTION_ARGS)
  * Optionally determines the collation.
  */
 static int
-mcv_match_expression(Node *expr, Bitmapset *keys, List *exprs, Oid *collid)
+mcv_match_expression(Node *expr, List *exprs, Oid *collid)
 {
-	int			idx;
+	bool		expr_is_var = IsA(expr, Var);
+	int			idx = 0;
+	ListCell   *lc;
 
-	if (IsA(expr, Var))
-	{
-		/* simple Var, so just lookup using varattno */
-		Var		   *var = (Var *) expr;
-
-		if (collid)
-			*collid = var->varcollid;
-
-		idx = bms_member_index(keys, var->varattno);
+	if (collid)
+		*collid = expr_is_var ? ((Var *) expr)->varcollid : exprCollation(expr);
 
-		if (idx < 0)
-			elog(ERROR, "variable not found in statistics object");
-	}
-	else
+	foreach(lc, exprs)
 	{
-		/* expression - lookup in stats expressions */
-		ListCell   *lc;
+		Node	   *node = (Node *) lfirst(lc);
 
-		if (collid)
-			*collid = exprCollation(expr);
-
-		/* expressions are stored after the simple columns */
-		idx = bms_num_members(keys);
-		foreach(lc, exprs)
+		if (expr_is_var)
 		{
-			Node	   *stat_expr = (Node *) lfirst(lc);
-
-			if (equal(expr, stat_expr))
-				break;
-
-			idx++;
+			if (IsA(node, Var) &&
+				((Var *) node)->varattno == ((Var *) expr)->varattno)
+				return idx;
 		}
+		else if (equal(expr, node))
+			return idx;
 
-		if (lc == NULL)
-			elog(ERROR, "expression not found in statistics object");
+		idx++;
 	}
 
-	return idx;
+	if (expr_is_var)
+		elog(ERROR, "variable not found in statistics object");
+	else
+		elog(ERROR, "expression not found in statistics object");
+
+	return -1;					/* keep compiler quiet */
 }
 
 /*
@@ -1594,7 +1583,7 @@ mcv_match_expression(Node *expr, Bitmapset *keys, List *exprs, Oid *collid)
  */
 static bool *
 mcv_get_match_bitmap(PlannerInfo *root, List *clauses,
-					 Bitmapset *keys, List *exprs,
+					 List *exprs,
 					 MCVList *mcvlist, bool is_or)
 {
 	ListCell   *l;
@@ -1644,7 +1633,7 @@ mcv_get_match_bitmap(PlannerInfo *root, List *clauses,
 				elog(ERROR, "incompatible clause");
 
 			/* match the attribute/expression to a dimension of the statistic */
-			idx = mcv_match_expression(clause_expr, keys, exprs, &collid);
+			idx = mcv_match_expression(clause_expr, exprs, &collid);
 
 			/*
 			 * Walk through the MCV items and evaluate the current clause. We
@@ -1751,7 +1740,7 @@ mcv_get_match_bitmap(PlannerInfo *root, List *clauses,
 			}
 
 			/* match the attribute/expression to a dimension of the statistic */
-			idx = mcv_match_expression(clause_expr, keys, exprs, &collid);
+			idx = mcv_match_expression(clause_expr, exprs, &collid);
 
 			/*
 			 * Walk through the MCV items and evaluate the current clause. We
@@ -1822,7 +1811,7 @@ mcv_get_match_bitmap(PlannerInfo *root, List *clauses,
 			Node	   *clause_expr = (Node *) (expr->arg);
 
 			/* match the attribute/expression to a dimension of the statistic */
-			int			idx = mcv_match_expression(clause_expr, keys, exprs, NULL);
+			int			idx = mcv_match_expression(clause_expr, exprs, NULL);
 
 			/*
 			 * Walk through the MCV items and evaluate the current clause. We
@@ -1864,7 +1853,7 @@ mcv_get_match_bitmap(PlannerInfo *root, List *clauses,
 			Assert(list_length(bool_clauses) >= 2);
 
 			/* build the match bitmap for the OR-clauses */
-			bool_matches = mcv_get_match_bitmap(root, bool_clauses, keys, exprs,
+			bool_matches = mcv_get_match_bitmap(root, bool_clauses, exprs,
 												mcvlist, is_orclause(clause));
 
 			/*
@@ -1891,7 +1880,7 @@ mcv_get_match_bitmap(PlannerInfo *root, List *clauses,
 			Assert(list_length(not_args) == 1);
 
 			/* build the match bitmap for the NOT-clause */
-			not_matches = mcv_get_match_bitmap(root, not_args, keys, exprs,
+			not_matches = mcv_get_match_bitmap(root, not_args, exprs,
 											   mcvlist, false);
 
 			/*
@@ -1911,7 +1900,7 @@ mcv_get_match_bitmap(PlannerInfo *root, List *clauses,
 			Var		   *var = (Var *) (clause);
 
 			/* match the attribute to a dimension of the statistic */
-			int			idx = bms_member_index(keys, var->varattno);
+			int			idx = mcv_match_expression((Node *) var, exprs, NULL);
 
 			Assert(var->vartype == BOOLOID);
 
@@ -1939,7 +1928,7 @@ mcv_get_match_bitmap(PlannerInfo *root, List *clauses,
 			int			idx;
 
 			/* match the expression to a dimension of the statistic */
-			idx = mcv_match_expression(clause, keys, exprs, NULL);
+			idx = mcv_match_expression(clause, exprs, NULL);
 
 			/*
 			 * Walk through the MCV items and evaluate the current clause. We
@@ -2057,7 +2046,7 @@ mcv_clauselist_selectivity(PlannerInfo *root, StatisticExtInfo *stat,
 	mcv = statext_mcv_load(stat->statOid, rte->inh);
 
 	/* build a match bitmap for the clauses */
-	matches = mcv_get_match_bitmap(root, clauses, stat->keys, stat->exprs,
+	matches = mcv_get_match_bitmap(root, clauses, stat->exprs,
 								   mcv, false);
 
 	/* sum frequencies for all the matching MCV items */
@@ -2130,8 +2119,8 @@ mcv_clause_selectivity_or(PlannerInfo *root, StatisticExtInfo *stat,
 		*or_matches = palloc0_array(bool, mcv->nitems);
 
 	/* build the match bitmap for the new clause */
-	new_matches = mcv_get_match_bitmap(root, list_make1(clause), stat->keys,
-									   stat->exprs, mcv, false);
+	new_matches = mcv_get_match_bitmap(root, list_make1(clause), stat->exprs,
+									   mcv, false);
 
 	/*
 	 * Sum the frequencies for all the MCV items matching this clause and also
diff --git a/src/backend/statistics/mvdistinct.c b/src/backend/statistics/mvdistinct.c
index a6a904039e5..47f4c614285 100644
--- a/src/backend/statistics/mvdistinct.c
+++ b/src/backend/statistics/mvdistinct.c
@@ -121,6 +121,12 @@ statext_ndistinct_build(double totalrows, StatsBuildData *data)
 				Assert(AttributeNumberIsValid(item->attributes[j]));
 			}
 
+			/*
+			 * Order the attnums the way dump and restore needs (see
+			 * compare_attnums).
+			 */
+			qsort(item->attributes, k, sizeof(AttrNumber), compare_attnums);
+
 			item->ndistinct =
 				ndistinct_for_combination(totalrows, data, k, combination);
 
@@ -342,13 +348,13 @@ statext_ndistinct_free(MVNDistinct *ndistinct)
  * attributes list correspond to attnums/expressions defined by the extended
  * statistics object.
  *
- * Positive attnums are attributes which must be found in the stxkeys,
- * while negative attnums correspond to an expression number, no attribute
+ * Positive attnums correspond to table columns (excluding virtual generated
+ * columns), while negative attnums correspond to expressions.  No attribute
  * number can be below (0 - numexprs).
  */
 bool
 statext_ndistinct_validate(const MVNDistinct *ndistinct,
-						   const int2vector *stxkeys,
+						   const Bitmapset *keys,
 						   int numexprs, int elevel)
 {
 	int			attnum_expr_lowbound = 0 - numexprs;
@@ -369,15 +375,8 @@ statext_ndistinct_validate(const MVNDistinct *ndistinct,
 
 			if (attnum > 0)
 			{
-				/* attribute number in stxkeys */
-				for (int k = 0; k < stxkeys->dim1; k++)
-				{
-					if (attnum == stxkeys->values[k])
-					{
-						ok = true;
-						break;
-					}
-				}
+				/* attribute number in keys */
+				ok = bms_is_member(attnum, keys);
 			}
 			else if ((attnum < 0) && (attnum >= attnum_expr_lowbound))
 			{
diff --git a/src/backend/utils/adt/ruleutils.c b/src/backend/utils/adt/ruleutils.c
index 1d41c06201b..d8a4a7ca160 100644
--- a/src/backend/utils/adt/ruleutils.c
+++ b/src/backend/utils/adt/ruleutils.c
@@ -62,6 +62,7 @@
 #include "rewrite/rewriteHandler.h"
 #include "rewrite/rewriteManip.h"
 #include "rewrite/rewriteSupport.h"
+#include "statistics/statistics.h"
 #include "utils/array.h"
 #include "utils/builtins.h"
 #include "utils/fmgroids.h"
@@ -369,7 +370,7 @@ static char *pg_get_indexdef_worker(Oid indexrelid, int colno,
 static void make_propgraphdef_elements(StringInfo buf, Oid pgrelid, char pgekind);
 static void make_propgraphdef_labels(StringInfo buf, Oid elid, const char *elalias, Oid elrelid);
 static void make_propgraphdef_properties(StringInfo buf, Oid ellabelid, Oid elrelid);
-static char *pg_get_statisticsobj_worker(Oid statextid, bool columns_only,
+static char *pg_get_statisticsobj_worker(Oid statextid,
 										 bool missing_ok);
 static char *pg_get_partkeydef_worker(Oid relid, int prettyFlags,
 									  bool attrsOnly, bool missing_ok);
@@ -1972,7 +1973,7 @@ pg_get_statisticsobjdef(PG_FUNCTION_ARGS)
 	Oid			statextid = PG_GETARG_OID(0);
 	char	   *res;
 
-	res = pg_get_statisticsobj_worker(statextid, false, true);
+	res = pg_get_statisticsobj_worker(statextid, true);
 
 	if (res == NULL)
 		PG_RETURN_NULL();
@@ -1987,7 +1988,27 @@ pg_get_statisticsobjdef(PG_FUNCTION_ARGS)
 char *
 pg_get_statisticsobjdef_string(Oid statextid)
 {
-	return pg_get_statisticsobj_worker(statextid, false, false);
+	return pg_get_statisticsobj_worker(statextid, false);
+}
+
+/*
+ * Deparse one column or expression of an extended statistics object into the
+ * text used in its CREATE STATISTICS command.
+ */
+static char *
+deparse_stat_entry(Node *expr, Oid relid, List *context)
+{
+	char	   *str;
+
+	if (IsA(expr, Var) && ((Var *) expr)->varattno > 0)
+		return pstrdup(quote_identifier(
+										get_attname(relid, ((Var *) expr)->varattno, false)));
+
+	str = deparse_expression_pretty(expr, context, false, false,
+									PRETTYFLAG_PAREN, 0);
+	if (looks_like_function(expr))
+		return str;
+	return psprintf("(%s)", str);
 }
 
 /*
@@ -1998,21 +2019,57 @@ Datum
 pg_get_statisticsobjdef_columns(PG_FUNCTION_ARGS)
 {
 	Oid			statextid = PG_GETARG_OID(0);
-	char	   *res;
+	Form_pg_statistic_ext statextrec;
+	HeapTuple	statexttup;
+	Datum		datum;
+	List	   *allexprs = NIL;
+	char	   *tmp;
+	List	   *context;
+	ListCell   *lc;
+	ArrayBuildState *astate = NULL;
 
-	res = pg_get_statisticsobj_worker(statextid, true, true);
+	statexttup = SearchSysCache1(STATEXTOID, ObjectIdGetDatum(statextid));
 
-	if (res == NULL)
+	if (!HeapTupleIsValid(statexttup))
 		PG_RETURN_NULL();
 
-	PG_RETURN_TEXT_P(string_to_text(res));
+	statextrec = (Form_pg_statistic_ext) GETSTRUCT(statexttup);
+
+	datum = SysCacheGetAttrNotNull(STATEXTOID, statexttup,
+								   Anum_pg_statistic_ext_stxexprs);
+	tmp = TextDatumGetCString(datum);
+	allexprs = (List *) stringToNode(tmp);
+	pfree(tmp);
+
+	context = deparse_context_for(get_relation_name(statextrec->stxrelid),
+								  statextrec->stxrelid);
+
+	foreach(lc, allexprs)
+	{
+		Node	   *expr = (Node *) lfirst(lc);
+		char	   *str;
+
+		str = deparse_stat_entry(expr, statextrec->stxrelid, context);
+		astate = accumArrayResult(astate,
+								  PointerGetDatum(cstring_to_text(str)),
+								  false,
+								  TEXTOID,
+								  CurrentMemoryContext);
+	}
+
+	ReleaseSysCache(statexttup);
+
+	if (astate == NULL)
+		PG_RETURN_NULL();
+
+	PG_RETURN_DATUM(makeArrayResult(astate, CurrentMemoryContext));
 }
 
 /*
  * Internal workhorse to decompile an extended statistics object.
  */
 static char *
-pg_get_statisticsobj_worker(Oid statextid, bool columns_only, bool missing_ok)
+pg_get_statisticsobj_worker(Oid statextid, bool missing_ok)
 {
 	Form_pg_statistic_ext statextrec;
 	HeapTuple	statexttup;
@@ -2022,6 +2079,7 @@ pg_get_statisticsobj_worker(Oid statextid, bool columns_only, bool missing_ok)
 	ArrayType  *arr;
 	char	   *enabled;
 	Datum		datum;
+	char	   *exprsString;
 	bool		ndistinct_enabled;
 	bool		dependencies_enabled;
 	bool		mcv_enabled;
@@ -2029,7 +2087,6 @@ pg_get_statisticsobj_worker(Oid statextid, bool columns_only, bool missing_ok)
 	List	   *context;
 	ListCell   *lc;
 	List	   *exprs = NIL;
-	bool		has_exprs;
 	int			ncolumns;
 
 	statexttup = SearchSysCache1(STATEXTOID, ObjectIdGetDatum(statextid));
@@ -2041,151 +2098,113 @@ pg_get_statisticsobj_worker(Oid statextid, bool columns_only, bool missing_ok)
 		elog(ERROR, "cache lookup failed for statistics object %u", statextid);
 	}
 
-	/* has the statistics expressions? */
-	has_exprs = !heap_attisnull(statexttup, Anum_pg_statistic_ext_stxexprs, NULL);
-
 	statextrec = (Form_pg_statistic_ext) GETSTRUCT(statexttup);
 
 	/*
-	 * Get the statistics expressions, if any.  (NOTE: we do not use the
-	 * relcache versions of the expressions, because we want to display
+	 * Get the statistics expressions.  (NOTE: we do not use the relcache
+	 * versions of the expressions, because we want to display
 	 * non-const-folded expressions.)
 	 */
-	if (has_exprs)
-	{
-		Datum		exprsDatum;
-		char	   *exprsString;
-
-		exprsDatum = SysCacheGetAttrNotNull(STATEXTOID, statexttup,
-											Anum_pg_statistic_ext_stxexprs);
-		exprsString = TextDatumGetCString(exprsDatum);
-		exprs = (List *) stringToNode(exprsString);
-		pfree(exprsString);
-	}
-	else
-		exprs = NIL;
+	datum = SysCacheGetAttrNotNull(STATEXTOID, statexttup,
+								   Anum_pg_statistic_ext_stxexprs);
+	exprsString = TextDatumGetCString(datum);
+	exprs = (List *) stringToNode(exprsString);
+	pfree(exprsString);
 
 	/* count the number of columns (attributes and expressions) */
-	ncolumns = statextrec->stxkeys.dim1 + list_length(exprs);
+	ncolumns = list_length(exprs);
 
 	initStringInfo(&buf);
 
-	if (!columns_only)
-	{
-		nsp = get_namespace_name_or_temp(statextrec->stxnamespace);
-		appendStringInfo(&buf, "CREATE STATISTICS %s",
-						 quote_qualified_identifier(nsp,
-													NameStr(statextrec->stxname)));
+	nsp = get_namespace_name_or_temp(statextrec->stxnamespace);
+	appendStringInfo(&buf, "CREATE STATISTICS %s",
+					 quote_qualified_identifier(nsp,
+												NameStr(statextrec->stxname)));
 
-		/*
-		 * Decode the stxkind column so that we know which stats types to
-		 * print.
-		 */
-		datum = SysCacheGetAttrNotNull(STATEXTOID, statexttup,
-									   Anum_pg_statistic_ext_stxkind);
-		arr = DatumGetArrayTypeP(datum);
-		if (ARR_NDIM(arr) != 1 ||
-			ARR_HASNULL(arr) ||
-			ARR_ELEMTYPE(arr) != CHAROID)
-			elog(ERROR, "stxkind is not a 1-D char array");
-		enabled = (char *) ARR_DATA_PTR(arr);
-
-		ndistinct_enabled = false;
-		dependencies_enabled = false;
-		mcv_enabled = false;
-
-		for (i = 0; i < ARR_DIMS(arr)[0]; i++)
-		{
-			if (enabled[i] == STATS_EXT_NDISTINCT)
-				ndistinct_enabled = true;
-			else if (enabled[i] == STATS_EXT_DEPENDENCIES)
-				dependencies_enabled = true;
-			else if (enabled[i] == STATS_EXT_MCV)
-				mcv_enabled = true;
-
-			/* ignore STATS_EXT_EXPRESSIONS (it's built automatically) */
-		}
+	/*
+	 * Decode the stxkind column so that we know which stats types to print.
+	 */
+	datum = SysCacheGetAttrNotNull(STATEXTOID, statexttup,
+								   Anum_pg_statistic_ext_stxkind);
+	arr = DatumGetArrayTypeP(datum);
+	if (ARR_NDIM(arr) != 1 ||
+		ARR_HASNULL(arr) ||
+		ARR_ELEMTYPE(arr) != CHAROID)
+		elog(ERROR, "stxkind is not a 1-D char array");
+	enabled = (char *) ARR_DATA_PTR(arr);
 
-		/*
-		 * If any option is disabled, then we'll need to append the types
-		 * clause to show which options are enabled.  We omit the types clause
-		 * on purpose when all options are enabled, so a pg_dump/pg_restore
-		 * will create all statistics types on a newer postgres version, if
-		 * the statistics had all options enabled on the original version.
-		 *
-		 * But if the statistics is defined on just a single column, it has to
-		 * be an expression statistics. In that case we don't need to specify
-		 * kinds.
-		 */
-		if ((!ndistinct_enabled || !dependencies_enabled || !mcv_enabled) &&
-			(ncolumns > 1))
-		{
-			bool		gotone = false;
+	ndistinct_enabled = false;
+	dependencies_enabled = false;
+	mcv_enabled = false;
 
-			appendStringInfoString(&buf, " (");
+	for (i = 0; i < ARR_DIMS(arr)[0]; i++)
+	{
+		if (enabled[i] == STATS_EXT_NDISTINCT)
+			ndistinct_enabled = true;
+		else if (enabled[i] == STATS_EXT_DEPENDENCIES)
+			dependencies_enabled = true;
+		else if (enabled[i] == STATS_EXT_MCV)
+			mcv_enabled = true;
 
-			if (ndistinct_enabled)
-			{
-				appendStringInfoString(&buf, "ndistinct");
-				gotone = true;
-			}
+		/* ignore STATS_EXT_EXPRESSIONS (it's built automatically) */
+	}
 
-			if (dependencies_enabled)
-			{
-				appendStringInfo(&buf, "%sdependencies", gotone ? ", " : "");
-				gotone = true;
-			}
+	/*
+	 * If any option is disabled, then we'll need to append the types clause
+	 * to show which options are enabled.  We omit the types clause on purpose
+	 * when all options are enabled, so a pg_dump/pg_restore will create all
+	 * statistics types on a newer postgres version, if the statistics had all
+	 * options enabled on the original version.
+	 *
+	 * But if the statistics is defined on just a single column, it has to be
+	 * an expression statistics. In that case we don't need to specify kinds.
+	 */
+	if ((!ndistinct_enabled || !dependencies_enabled || !mcv_enabled) &&
+		(ncolumns > 1))
+	{
+		bool		gotone = false;
 
-			if (mcv_enabled)
-				appendStringInfo(&buf, "%smcv", gotone ? ", " : "");
+		appendStringInfoString(&buf, " (");
 
-			appendStringInfoChar(&buf, ')');
+		if (ndistinct_enabled)
+		{
+			appendStringInfoString(&buf, "ndistinct");
+			gotone = true;
 		}
 
-		appendStringInfoString(&buf, " ON ");
-	}
-
-	/* decode simple column references */
-	for (colno = 0; colno < statextrec->stxkeys.dim1; colno++)
-	{
-		AttrNumber	attnum = statextrec->stxkeys.values[colno];
-		char	   *attname;
-
-		if (colno > 0)
-			appendStringInfoString(&buf, ", ");
+		if (dependencies_enabled)
+		{
+			appendStringInfo(&buf, "%sdependencies", gotone ? ", " : "");
+			gotone = true;
+		}
 
-		attname = get_attname(statextrec->stxrelid, attnum, false);
+		if (mcv_enabled)
+			appendStringInfo(&buf, "%smcv", gotone ? ", " : "");
 
-		appendStringInfoString(&buf, quote_identifier(attname));
+		appendStringInfoChar(&buf, ')');
 	}
 
+	appendStringInfoString(&buf, " ON ");
+
 	context = deparse_context_for(get_relation_name(statextrec->stxrelid),
 								  statextrec->stxrelid);
 
+	colno = 0;
 	foreach(lc, exprs)
 	{
 		Node	   *expr = (Node *) lfirst(lc);
-		char	   *str;
-		int			prettyFlags = PRETTYFLAG_PAREN;
-
-		str = deparse_expression_pretty(expr, context, false, false,
-										prettyFlags, 0);
 
 		if (colno > 0)
 			appendStringInfoString(&buf, ", ");
 
-		/* Need parens if it's not a bare function call */
-		if (looks_like_function(expr))
-			appendStringInfoString(&buf, str);
-		else
-			appendStringInfo(&buf, "(%s)", str);
-
+		appendStringInfoString(&buf,
+							   deparse_stat_entry(expr, statextrec->stxrelid,
+												  context));
 		colno++;
 	}
 
-	if (!columns_only)
-		appendStringInfo(&buf, " FROM %s",
-						 generate_relation_name(statextrec->stxrelid, NIL));
+	appendStringInfo(&buf, " FROM %s",
+					 generate_relation_name(statextrec->stxrelid, NIL));
 
 	ReleaseSysCache(statexttup);
 
@@ -2202,10 +2221,12 @@ pg_get_statisticsobjdef_expressions(PG_FUNCTION_ARGS)
 	Form_pg_statistic_ext statextrec;
 	HeapTuple	statexttup;
 	Datum		datum;
+	Relation	rel;
 	List	   *context;
 	ListCell   *lc;
+	ListCell   *lc_raw;
+	List	   *rawexprs = NIL;
 	List	   *exprs = NIL;
-	bool		has_exprs;
 	char	   *tmp;
 	ArrayBuildState *astate = NULL;
 
@@ -2214,37 +2235,51 @@ pg_get_statisticsobjdef_expressions(PG_FUNCTION_ARGS)
 	if (!HeapTupleIsValid(statexttup))
 		PG_RETURN_NULL();
 
-	/* Does the stats object have expressions? */
-	has_exprs = !heap_attisnull(statexttup, Anum_pg_statistic_ext_stxexprs, NULL);
-
-	/* no expressions? we're done */
-	if (!has_exprs)
-	{
-		ReleaseSysCache(statexttup);
-		PG_RETURN_NULL();
-	}
-
 	statextrec = (Form_pg_statistic_ext) GETSTRUCT(statexttup);
 
 	/*
-	 * Get the statistics expressions, and deparse them into text values.
+	 * Decode stxexprs as originally written; we deparse these, because we
+	 * want to display the expressions without const-folding.
 	 */
 	datum = SysCacheGetAttrNotNull(STATEXTOID, statexttup,
 								   Anum_pg_statistic_ext_stxexprs);
 	tmp = TextDatumGetCString(datum);
-	exprs = (List *) stringToNode(tmp);
+	rawexprs = (List *) stringToNode(tmp);
 	pfree(tmp);
 
+	/*
+	 * exprs is rawexprs with virtual generated columns expanded and
+	 * expressions const-folded; the transforms are per-node, so it stays
+	 * element-aligned with rawexprs -- we classify on the folded exprs but
+	 * deparse the original rawexpr.  Dropping the plain-column entries leaves
+	 * exactly the complex expressions, in the same order as stxdexpr, which
+	 * pg_stats_ext_exprs pairs this output with.
+	 */
+	rel = table_open(statextrec->stxrelid, AccessShareLock);
+	exprs = statext_get_stxexprs(statexttup, rel);
+	table_close(rel, AccessShareLock);
+
+	Assert(list_length(exprs) == list_length(rawexprs));
+
 	context = deparse_context_for(get_relation_name(statextrec->stxrelid),
 								  statextrec->stxrelid);
 
-	foreach(lc, exprs)
+	forboth(lc, exprs, lc_raw, rawexprs)
 	{
 		Node	   *expr = (Node *) lfirst(lc);
+		Node	   *rawexpr = (Node *) lfirst(lc_raw);
 		char	   *str;
 		int			prettyFlags = PRETTYFLAG_INDENT;
 
-		str = deparse_expression_pretty(expr, context, false, false,
+		/*
+		 * Skip entries that resolve to a plain column: their statistics are
+		 * in pg_statistic, not in pg_statistic_ext_data.stxdexpr, so they are
+		 * not part of the list we return.
+		 */
+		if (statext_is_column(expr))
+			continue;
+
+		str = deparse_expression_pretty(rawexpr, context, false, false,
 										prettyFlags, 0);
 
 		astate = accumArrayResult(astate,
@@ -2256,6 +2291,9 @@ pg_get_statisticsobjdef_expressions(PG_FUNCTION_ARGS)
 
 	ReleaseSysCache(statexttup);
 
+	if (astate == NULL)
+		PG_RETURN_NULL();
+
 	PG_RETURN_DATUM(makeArrayResult(astate, CurrentMemoryContext));
 }
 
